﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        private ObservableCollection<People> _Peoples;
        public ObservableCollection<People> Peoples
        {
            get { return _Peoples; }
            set { _Peoples = value; }
        }
        private GridSettings _settings;

        public GridSettings Settings
        {
            get { return _settings; }
            set { _settings = value; OnChanged("Settings"); }
        }

        public MainWindow()
        {
            InitializeComponent();
            Settings = xdg.Resources["gs"] as GridSettings;
            Loaded += new RoutedEventHandler(MainWindow_Loaded);
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            Peoples = new ObservableCollection<People>();
            for (int i = 0; i < 10; i++)
            {
                Peoples.Add(new People() { Id = i + 1, Name = "Name" + i.ToString() });
            }

            this.DataContext = this;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnChanged(string Name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(Name));
            }
        }
    }

    public class People : INotifyPropertyChanged
    {


        private int _Id;

        public int Id
        {
            get { return _Id; }
            set { _Id = value; OnChanged("Id"); }
        }


        private string _Name;
        public string Name
        {
            get { return _Name; }
            set { _Name = value; OnChanged("Name"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnChanged(string Name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(Name));
            }
        }
    }

    public class GridSettings : INotifyPropertyChanged
    {

        private bool _AllowFilter;
        public bool AllowFilter
        {
            get { return _AllowFilter; }
            set { _AllowFilter = value; OnChanged("AllowFilter"); }
        }

        private Brush _AlternateBackground;

        public Brush AlternateBackground
        {
            get { return _AlternateBackground; }
            set { _AlternateBackground = value; OnChanged("AlternateBackground"); }
        }


        public event PropertyChangedEventHandler PropertyChanged;
        public void OnChanged(string Name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(Name));
            }
        }
    }
}

